;---------------------   ---------------------------
; :                         
;                                                             
; :  Ivan_fd                             
;                                                             
; : 1.0.0.58  30.08.2009  
;                                                             
; :  ,      


Device = 16F876A
Declare XTAL = 10
'ALL_DIGITAL = On
REMINDERS = OFF
Config HS_OSC , WDT_OFF ,  PWRTE_ON , BODEN_OFF , LVP_OFF ,  CP_OFF, CPD_OFF 
REMINDERS = On

    Symbol T0IF     = INTCON.2   
    Symbol T0IE     = INTCON.5         

Dim Cifra6		As Byte			;   
Dim Cifra5		As Byte			; 
Dim Cifra4		As Byte			; 
Dim Cifra3	As Byte			; 
Dim Cifra2		As Byte			; 
Dim Cifra1		As Byte			; 

Dim tmp         As Byte         ;    ()

Dim ADDRESS		As Byte			;      
Dim SELECTOR	As Byte			;   

Dim OUTA		As Byte			; 

Dim Cifra       As Byte
Dim DigitDisp   As Byte          ;  
'========================================================
'********       
'========================================================
    Symbol dq   = PORTA.4			' 
    Symbol led  = PORTC.5			' 
    Dim Temp_read   As  Word
    Dim Sign        As  Byte
    Dim TempC       As  Byte
    Dim TemperC     As  Word 
    Dim Float0      As  Byte
    Dim Float1      As  Byte
    
	Dim command     As     Byte            ' Storage for command
	Dim i           As     Byte            ' Storage for loop counter


    Dim Reg_1       As Byte
    Dim Reg_2       As Byte
    Dim Reg_3       As Byte


'========================================================



ASM
mvi     MACRO   DEST2,CONST2       
	movlw   CONST2
	movwf   DEST2
	ENDM	
ENDASM
 Declare FSR_CONTEXT_SAVE = On 
 ON_HARDWARE_INTERRUPT GoTo MYINT


init:	   					'
'******************************************************************************************************
        OPTION_REG = %10000010
   		INTCON 	= %10100000
        TRISA = %00000000
        TRISB = %00000000
        ADCON1 = $6

 		OUTA = %11101111	; 
    	PORTA = %11111111
		PORTB = %00000000	;
        SELECTOR = 6
  ASM
		mvi	ADDRESS,Cifra6		;  ADDRESS     
'		mvi	SELECTOR,b'11101111'	;  

		mvi	Cifra6,b'01000000'	;³ "_OFF"
		mvi	Cifra5,b'01110001'
		mvi	Cifra4,b'01110001'
		mvi	Cifra3,b'00111111'
        mvi Cifra2,b'01000000'
        mvi Cifra1,b'00000000'
ENDASM		
        'TemperC = 59           ' 
        'GoSub valtempver       '      
GoTo mainloop

MYINT:'-----------------------------------------------------------------
If dq = 0 Then            
            OUTA = %11101111
            Else
            OUTA = %11111111
            EndIf
             
            PORTA = OUTA
            
            OUTA = SELECTOR - 1

        FSR = ADDRESS      ;   FSR   
        PORTB = INDF       ;        FIG....
        PORTA = OUTA

'        STATUS.0 = 1
        Dec SELECTOR
                
        If SELECTOR = 0 Then
            ASM 
        		movlw	Cifra6			;     
        		movwf	ADDRESS			;   ADDRESS
            ENDASM
		SELECTOR = 6	;  
        GoTo End_int
        EndIf
Int_label:
	Inc      ADDRESS             ;  
	ASM
    	nop
		nop
		GoTo      End_int               
    ENDASM
End_int:
 T0IF = 0                        ' Clear the TMR0 overflow flag 
 Context Restore                 ' Restore the registers and exit the interrupt


'*********************************************************************************
'                                  *   *
'********************************************************************************* 

 mainloop:
        tmp = SELECTOR
            While tmp = SELECTOR    '    (      
            Wend                    ' SELECTOR )
        GoSub init1820          ' Init the DS1820


        command = $cc           ' Issue Skip ROM command
        tmp = SELECTOR
            While tmp = SELECTOR    '  ..............
            Wend                    ' 
        GoSub write1820

        command = $44           ' Start temperature conversion
        tmp = SELECTOR
            While tmp = SELECTOR    '   ..............
            Wend                    ' 
        GoSub write1820

        DelayUS 1              ' Wait 2 seconds for conversion to complete


ASM
;  760 
;    10 

            movlw       .127
            movwf       Reg_1
            movlw       .164
            movwf       Reg_2
            movlw       .10
            movwf       Reg_3
delay       decfsz      Reg_1,F
            GoTo        delay
            decfsz      Reg_2,F
            GoTo        delay
            decfsz      Reg_3,F
            GoTo        delay
            nop
            nop            
ENDASM


        tmp = SELECTOR
            While tmp = SELECTOR      '      
            Wend                      ' 
        GoSub init1820            ' Do another init

        command = $cc             ' Issue Skip ROM command
        tmp = SELECTOR
            While tmp = SELECTOR      '
            Wend                      ' 
        GoSub write1820

        command = $be             ' Read the temperature
        tmp = SELECTOR
            While tmp = SELECTOR      '  
            Wend                      ' 
        GoSub write1820

        tmp = SELECTOR
            While tmp = SELECTOR      ' 
            Wend                      ' 
        GoSub read1820

        GoSub Temp_calc               '    
        GoSub rozr                    '   
        ' Display the decimal temperature

        GoTo mainloop                  '  



    Temp_calc:					'  
'******************************************************************************************************
    If Temp_read.11 = 1 Then  ' 
        Sign = "-"
        Temp_read = ~Temp_read + 1 
    Else
        Sign = "+"
    EndIf
    TempC  = (Temp_read & $0FF0) >> 4 
    Float1 = Temp_read.LowByte & $0F
    Float0 = LookUpL Float1, [0,1,1,2,2,3,4,4,5,6,6,7,7,8,9,9]
    TemperC = (TempC * 10) + Float0
    Return
'   ,  valtemp   valtemp1
rozr:
    Cifra =  TemperC Dig 2

    If  Cifra = 0 Then
       GoSub valtemp1
    Else
        GoSub valtemp   
    EndIf
    Return
'=================================================================
'        ()
'=================================================================    
valtemp:
    Cifra6 = %01100011

    DigitDisp = TemperC Dig 0   ' 
    GoSub LOOK
    Cifra5 = Cifra

    DigitDisp = TemperC Dig 1   ' 
    GoSub LOOK
    Cifra4 = Cifra + 128

    DigitDisp = TemperC Dig 2   ' 
    GoSub LOOK
    Cifra3 = Cifra
    
    If Sign = "-" Then
        Cifra2 = %01000000 ;  
    Else
        Cifra2 = %00000000 ;  C
    EndIf            
    Cifra1 = %01111000
    
Return
    
LOOK:
        ;       
        Cifra = LookUpL DigitDisp,[63,6,91,79,102,109,125,7,127,111]         
        Return

'=================================================================
'        ( .  )
'=================================================================    

valtemp1:
    Cifra6 = $00
    Cifra5 = %01100011

    DigitDisp = TemperC Dig 0   ' 
    GoSub LOOK
    Cifra4 = Cifra

    DigitDisp = TemperC Dig 1   ' 
    GoSub LOOK
    Cifra3 = Cifra + 128

'    DigitDisp = TemperC Dig 2   ' 
'    GoSub LOOK
'    Cifra2 = Cifra
    
    If Sign = "-" Then
        Cifra2 = %01000000 ;  
    Else
        Cifra2 = %00000000 ;  C
    EndIf            
    Cifra1 = %01111000
Return


valtempver:
    DigitDisp = TemperC Dig 0   ' 
    GoSub LOOK
    Cifra6 = Cifra

    DigitDisp = TemperC Dig 1   ' 
    GoSub LOOK
    Cifra5 = Cifra

    Cifra4 = %01000000
    
    Cifra3 = %00111110 

Return        
'=======================================================================
'      
'=======================================================================

' Initialize DS1820 and check for presence
init1820:

        Low dq                  ' Set the data pin low to init
        DelayUS 500             ' Wait > 480us
        Input dq              ' Release data pin (set to input for high)
        High led
        DelayUS 100             ' Wait > 60us
        If dq = 1 Then
        Low led
                DelayMS 500

                Return   ' Try again
        EndIf
        DelayUS 400             ' Wait for end of presence pulse
        Low led

        Return


' Write "command" byte to the DS1820
write1820:
        T0IE = 0 '    TMR0
        For i = 1 To 8          ' 8 bits to a byte
                If command.0 = 0 Then
                        GoSub write0    ' Write a 0 bit
                Else
                        GoSub write1    ' Write a 1 bit
                EndIf
                command = command >> 1  ' Shift to next bit
        Next i
        T0IE = 1 '    TMR0
        Return

' Write a 0 bit to the DS1820
write0:
        Low dq
        DelayUS 60              ' Low for > 60us for 0
        Input dq              ' Release data pin (set to input for high)
        Return

' Write a 1 bit to the DS1820
write1:
        Low dq                  ' Low for < 15us for 1
@       nop                     ' Delay 1us at 4MHz
        Input dq              ' Release data pin (set to input for high)
        DelayUS 60              ' Use up rest of time slot
        Return


' Read temperature from the DS1820
read1820:

        T0IE = 0 '    TMR0
        For i = 1 To 16         ' 16 bits to a word
                Temp_read = Temp_read >> 1        ' Shift down bits
                GoSub readbit   ' Get the bit to the top of temp
        Next i
        T0IE = 1 '    TMR0

        Return

' Read a bit from the DS1820
readbit:
        Temp_read.15 = 1             ' Preset read bit to 1
        Low dq                  ' Start the time slot
@       nop                     ' Delay 1us at 4MHz
        Input dq              ' Release data pin (set to input for high)
        If dq = 0 Then
                Temp_read.15 = 0     ' Set bit to 0
        EndIf
        DelayUS 60              ' Wait out rest of time slot
        Return

        End
